
mrGearboxMogliRegister = {};
mrGearboxMogliRegister.isLoaded = true;
mrGearboxMogliRegister.g_currentModDirectory = g_currentModDirectory;

if SpecializationUtil.specializations["mrGearboxMogliLoader"] == nil then
	SpecializationUtil.registerSpecialization("mrGearboxMogliLoader", "mrGearboxMogliLoader", g_currentModDirectory.."mrGearboxMogliLoader.lua")
	SpecializationUtil.registerSpecialization("mrSoundEngineFix", "mrSoundEngineFix", g_currentModDirectory.."mrSoundEngineFix.lua")
	mrGearboxMogliRegister.isLoaded = false;
end;

function mrGearboxMogliRegister:loadMap(name)	
  if not mrGearboxMogliRegister.isLoaded then	
		mrGearboxMogliRegister:add();
    mrGearboxMogliRegister.isLoaded = true;
  end;
end;

function mrGearboxMogliRegister:deleteMap()
  --mrGearboxMogliRegister.isLoaded = false;
end;

function mrGearboxMogliRegister:mouseEvent(posX, posY, isDown, isUp, button)
end;

function mrGearboxMogliRegister:keyEvent(unicode, sym, modifier, isDown)
end;

function mrGearboxMogliRegister:update(dt)
end;

function mrGearboxMogliRegister:draw()
end;

function mrGearboxMogliRegister:add()
	local searchTable = { "mrGearboxMogli", "mrGearboxXerion", "mrGearbox2" };	
	
	for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
		local modName           = string.match(k, "([^.]+)");
		local addSpecialization = true;
		local correctLocation   = false;
		
		for _, search in pairs(searchTable) do
			if SpecializationUtil.specializations[modName .. "." .. search] ~= nil then
				addSpecialization = false;
				break;
			end;
		end;
		
		for i = 1, table.maxn(v.specializations) do
			local vs = v.specializations[i];
			if      vs ~= nil 
					and vs == SpecializationUtil.getSpecialization("realisticMotorized") then
				correctLocation = true;
				break;
			end;
		end;
		
		if addSpecialization and correctLocation then
			table.insert(v.specializations, SpecializationUtil.getSpecialization("mrGearboxMogliLoader"));
			
			for i = 1, table.maxn(v.specializations) do
				local vs = v.specializations[i];
				if      vs ~= nil 
						and vs == SpecializationUtil.getSpecialization("realisticVehicle") then
					table.insert(v.specializations, i+1, SpecializationUtil.getSpecialization("mrSoundEngineFix"));
					break;
				end;
			end;

			--	print("  mrGearboxMogli was inserted into " .. k);
	--elseif correctLocation and not addSpecialization then
	--	print("  Failed to insert mrGearboxMogli into " .. k );
		end;
	end;
	
	-- make l10n global 
	--g_i18n.globalI18N.texts["AUTO_TRACTOR_VERSION"]                  = g_i18n:getText("AUTO_TRACTOR_VERSION");
	
end;

addModEventListener(mrGearboxMogliRegister);
